﻿//	Spludlow Software
//	Copyright © Samuel P. Ludlow 2020 All Rights Reserved
//	Distributed under the terms of the GNU General Public License version 3
//	Distributed WITHOUT ANY WARRANTY; without implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE
//	https://www.spludlow.co.uk/LICENCE.TXT
//	The Spludlow logo is a registered trademark of Samuel P. Ludlow and may not be used without permission
//	v1.14

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Data;
using System.Drawing;

namespace Spludlow.Printing
{
	public interface IPrintDoc
	{
		void NewPage();

		void Text(string text, string font, float x, float y, Color colour, float angle, StringAlignment alignment, float strokeWidth, Color strokeColour);

		void TextBox(string text, string font, float x, float y, float width, float height, Color colour, float angle, StringAlignment alignment, float strokeWidth, Color strokeColour);

		void Line(float x1, float y1, float x2, float y2, float lineWidth, Color lineColour);

		void Rectangle(float x, float y, float width, float height, float lineWidth, Color lineColour, Color fillColour);

		void Cirlce(float x, float y, float radius, float lineWidth, Color lineColour, Color fillColour);

		void Ellipse(float x, float y, float xRadius, float yRadius, float lineWidth, Color lineColour, Color fillColour);

		void Arc(float x, float y, float xRadius, float yRadius, float startAngle, float endAngle, float lineWidth, Color lineColour);

		void ArcSector(float x, float y, float xOuterRadius, float yOuterRadius, float xInnerRadius, float yInnerRadius, float startAngle, float endAngle, float lineWidth, Color lineColour, Color fillColour);

		void Polygon(float x, float y, float xRadius, float yRadius, int sides, float rotateAngle, float lineWidth, Color lineColour, Color fillColour);

		void Shape(PointF[] points, float lineWidth, Color lineColour, Color fillColour);

		void Curve(PointF[] points, float lineWidth, Color lineColour);

		void Lines(PointF[] points, float lineWidth, Color lineColour);

		void Place(string filename, float x, float y, float scale, int sourcePageNumber);

		void PlaceAngle(string filename, float x, float y, float scale, float angle, int sourcePageNumber);

		void BarCode(string data, string type, float x, float y, float width, float height, Color foreColour, Color backColour, bool rotate);
	}
}
