﻿//	Spludlow Software
//	Copyright © Samuel P. Ludlow 2020 All Rights Reserved
//	Distributed under the terms of the GNU General Public License version 3
//	Distributed WITHOUT ANY WARRANTY; without implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE
//	https://www.spludlow.co.uk/LICENCE.TXT
//	The Spludlow logo is a registered trademark of Samuel P. Ludlow and may not be used without permission
//	v1.14

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;

namespace Spludlow
{
	public class RemoteIO
	{
		public static string[] DirectoryGetFiles(string host, string path)
		{
			return (string[])Spludlow.Call.Now(host, "System", "System.IO.Directory", "GetFiles", new object[] { path }, CallFlags.LargeResult);
		}
		public static string[] DirectoryGetFiles(string host, string path, string searchPattern)
		{
			return (string[])Spludlow.Call.Now(host, "System", "System.IO.Directory", "GetFiles", new object[] { path, searchPattern }, CallFlags.LargeResult);
		}
		public static string[] DirectoryGetDirectories(string host, string path)
		{
			return (string[])Spludlow.Call.Now(host, "System", "System.IO.Directory", "GetDirectories", new object[] { path }, CallFlags.LargeResult);
		}
		public static string[] DirectoryGetDirectories(string host, string path, string searchPattern)
		{
			return (string[])Spludlow.Call.Now(host, "System", "System.IO.Directory", "GetDirectories", new object[] { path, searchPattern }, CallFlags.LargeResult);
		}
		public static string[] DirectoryGetDirectories(string host, string path, string searchPattern, SearchOption searchOption)
		{
			return (string[])Spludlow.Call.Now(host, "System", "System.IO.Directory", "GetDirectories", new object[] { path, searchPattern, searchOption }, CallFlags.LargeResult);
		}
		public static bool DirectoryExists(string host, string path)
		{
			return (bool)Spludlow.Call.Now(host, "System", "System.IO.Directory", "Exists", new object[] { path });
		}
		public static void DirectoryCreateDirectory(string host, string path)
		{
			Spludlow.Call.Now(host, "System", "System.IO.Directory", "CreateDirectory", new object[] { path });
		}
		public static void DirectoryDelete(string host, string path, bool recursive)
		{
			Spludlow.Call.Now(host, "System", "System.IO.Directory", "Delete", new object[] { path, recursive });
		}
		public static void DirectoryMove(string host, string sourceDirName, string targetDirName)
		{
			Spludlow.Call.Now(host, "System", "System.IO.Directory", "Move", new object[] { sourceDirName, targetDirName });
		}
		public static void DirectoryCopy(string host, string sourceDirName, string targetDirName)
		{
			Spludlow.Call.Now(host, "Spludlow", "Spludlow.Io.Dirs", "Copy", new object[] { sourceDirName, targetDirName });
		}

		public static bool FileExists(string host, string path)
		{
			return (bool)Spludlow.Call.Now(host, "System", "System.IO.File", "Exists", new object[] { path });
		}
		public static void FileDelete(string host, string path)
		{
			Spludlow.Call.Now(host, "System", "System.IO.File", "Delete", new object[] { path });
		}
		public static void FileMove(string host, string sourceFileName, string targetFileName)
		{
			Spludlow.Call.Now(host, "System", "System.IO.File", "Move", new object[] { sourceFileName, targetFileName });
		}
		public static void FileCopy(string host, string sourceFileName, string targetFileName)
		{
			Spludlow.Call.Now(host, "System", "System.IO.File", "Copy", new object[] { sourceFileName, targetFileName });
		}
		public static void FileWriteAllText(string host, string path, string contents)
		{
			Spludlow.Call.Now(host, "System", "System.IO.File", "WriteAllText", new object[] { path, contents });
		}
	}
}
